Changes to bldpkg:

* Fixed code that prevented writing to BUILDMONITOR.html when $showsummary was set to 0 by moving it into its own separate function
* Also moved out code for cleaning up build files into a separate function
* Made miscellaneous fixes and removed unnecessary code
This commit is contained in:
PktSurf 2022-07-04 16:41:13 +05:30
parent 3835706f03
commit c006f22e5c

122
bldpkg
View file

@ -295,12 +295,9 @@ case "$pkgext" in
esac
# Borrowed from slackware's installpkg utility
echo -n "Validating $compressor...."
if ! $compressor --help > /dev/null 2>&1 ; then
echo "[FAILED]"
echo "[ERROR] Compressor validation FAILED! Aborting!"
exit 1
else
echo "[OK]"
fi
# Validate the TMPFS directory. If usetmpfs is set to 1 and tmpfsdir variable is set, then check for
@ -804,6 +801,7 @@ removestaticlibs() {
# Function to perform post-compile tasks:
# To be invoked inside a package build file.
mkfinalpkg() {
# Now we attempt to split the total time we'll get when making the summary into two times: compile time and
# packaging time. Here we store the value of $SECONDS variable the moment makefinalpkg is invoked. We use this
# value as the compile time, because this is the next function that's called by the build script the moment a
@ -883,10 +881,10 @@ mkfinalpkg() {
totalsymcount="$(find $pkg -type l | wc -l)"
packusize1="$(du -s $pkg | awk '{print $1}')"
# Here we ascertain the packaging time taken to actually prepare the final package. For this, we must reset the
# SECONDS variable to ensure accuracy
SECONDS=0
fi
# Here we ascertain the packaging time taken to actually prepare the final package. For this, we must reset the
# SECONDS variable to ensure accuracy
SECONDS=0
# Store package location inside this variable:
packlocation="$pkgdest/$app-$version-$arch-$build.$pkgext"
@ -902,12 +900,16 @@ mkfinalpkg() {
echo "[INFO] Re-entering source directory $srcdir"
cd "$srcdir"
if [ "$showsummary" == "1" ]; then
if [ "$showsummary" == "1" ] || [ "$htmloutput" == "1" ] ; then
# With SECONDS reset, the shell will add in a fresh value, which we can now use to ascertain the packaging time,
# by again passing that value as an argument to the runtime function
packagetimea="$SECONDS"
packagetimeb="$( runtime $packagetimea )"
fi
if [ "$showsummary" == "1" ]; then
# Determine size of SRCDIR aka source directory
srcdirsize="$(du -s $srcdir | awk '{print $1}')"
# Determine size of tmp aka build directory size
@ -945,11 +947,33 @@ mkfinalpkg() {
fi
}
prepbuildsummary() {
buildfilecleanup() {
# Discard all temporary files
rm -f "$parenttmp/BUILDING"
rm -f "$tempfile"
if [ -z "$autobuild" ] ; then
rm -f "$parenttmp/$app.{app,build,version}"
fi
}
prepbuildoutput() {
# Get the build completion time and store it in a variable
finishdate="$(date '+%a, %d %b %Y, %T')"
# If compiletimea is set, then do a sum total of compiletimea and packagetimea variables to get the
# total time in seconds and use that as an argument for the runtime function. If compiletimea is not set,
# invoke the runtime function alone on new reset $SECONDS
if [ -n "$compiletimea" ] && [ "$pkgstatus" = "0" ] ; then
finalcompiletime="$(( $compiletimea + $packagetimea ))"
totaltime="$( runtime $finalcompiletime )"
else
totaltime="$( runtime $SECONDS )"
fi
# Start of the showsummary if/else check
if [ "$showsummary" = "1" ]; then
@ -1041,29 +1065,23 @@ prepbuildsummary() {
else
makeflags="$MAKEFLAGS, auto-detected"
fi
# If compiletimea is set, then do a sum total of compiletimea and packagetimea variables to get the
# total time in seconds and use that as an argument for the runtime function. If compiletimea is not set,
# invoke the runtime function alone on new reset $SECONDS
if [ -n "$compiletimea" ] && [ "$pkgstatus" = "0" ] ; then
finalcompiletime="$(( $compiletimea + $packagetimea ))"
totaltime="$( runtime $finalcompiletime )"
else
totaltime="$( runtime $SECONDS )"
fi
#if [ -n "$compiletimea" ] && [ "$pkgstatus" = "0" ] ; then
# finalcompiletime="$(( $compiletimea + $packagetimea ))"
# totaltime="$( runtime $finalcompiletime )"
#else
# totaltime="$( runtime $SECONDS )"
#fi
# Determine if the build was successful or not
if [ "$pkgstatus" = "0" ] ; then
bldstatus="$(echo -e "$colourg"'Successful! :-D' "$colourd")"
if [ "$htmloutput" = "1" ] ; then
cat << EOF >> $parenttmp/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b></td><td>$commencedate</td><td>$finishdate</td><td>$totaltime</td><td><b style="color:#00cc00;">SUCCEEDED</b></td></tr>
EOF
rm -f "$parenttmp/BUILDING"
fi
# Determine the compressed size
packsize="$(du -bk "$packlocation" | awk '{print $1}')"
@ -1073,24 +1091,9 @@ EOF
elif [ "$wasinterrupted" = "1" ]; then
bldstatus="$(echo -e "$coloury"'** INTERRUPTED ** :-/'"$colourd")"
if [ "$htmloutput" = "1" ] ; then
cat << EOF >> $parenttmp/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b></td><td>$commencedate</td><td>$finishdate</td><td>$totaltime</td><td><b>INTERRUPTED</b></td></tr>
EOF
rm -f "$parenttmp/BUILDING"
fi
else
bldstatus="$(echo -e "$colourr"'!! FAILED !! :-('"$colourd")"
if [ "$htmloutput" = "1" ] ; then
cat << EOF >> $parenttmp/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b></td><td>$commencedate</td><td>$finishdate</td><td>$totaltime</td><td><b style="color:#ff1a1a;">FAILED</b></td></tr>
EOF
rm -f "$parenttmp/BUILDING"
fi
fi
# Finally prepare the summary
@ -1180,19 +1183,38 @@ EOF
# Output the build summary to the user on every build
cat "$tempfile"
# Once the output is shown, discard all temporary files
rm -f "$tempfile"
if [ -z "$autobuild" ] ; then
rm -f "$parenttmp/$app.{app,build,version}"
fi
fi
# Completion of the showsummary if/else check
# Discard temporary files
buildfilecleanup
# Show HTML output if enabled
prephtmloutput
# Prompt user for extracting/installing the package if the build has succeeded
promptuser
}
prephtmloutput() {
if [ "$htmloutput" = "1" ] ; then
if [ "$pkgstatus" = "0" ] ; then
cat << EOF >> $parenttmp/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b></td><td>$commencedate</td><td>$finishdate</td><td>$totaltime</td><td><b style="color:#00cc00;">SUCCEEDED</b></td></tr>
EOF
elif [ "$wasinterrupted" = "1" ]; then
cat << EOF >> $parenttmp/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b></td><td>$commencedate</td><td>$finishdate</td><td>$totaltime</td><td><b>INTERRUPTED</b></td></tr>
EOF
else
cat << EOF >> $parenttmp/BUILDMONITOR.html
<tr><td><b><i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b></td><td>$commencedate</td><td>$finishdate</td><td>$totaltime</td><td><b style="color:#ff1a1a;">FAILED</b></td></tr>
EOF
fi
fi
}
promptuser() {
# Prompt the user at the end of a build whether to extract contents of a newly-built installer into a subdirectory
# called "test" inside the package source directory the build was manually initiated from. Has no effect on
@ -1242,9 +1264,9 @@ promptuser() {
fi
}
# This function will set the interrupt variable so prepbuildsummary can output the right build status on receiving
# This function will set the interrupt variable so prepbuildoutput can output the right build status on receiving
# ctrl-c from the user during a manual build.
interruptsummary() {
interruptoutput() {
echo "Caught Keyboard Interrupt..."
wasinterrupted="1"
# If installprompt and extractprompt are set and the prompt is invoked after a successful build, hitting
@ -1256,13 +1278,13 @@ interruptsummary() {
# https://unix.stackexchange.com/questions/462392/bash-the-function-is-executed-twice
# https://stackoverflow.com/questions/9256644/identifying-received-signal-name-in-bash/9256709
# We use two traps to identify the signals, EXIT and INT. EXIT will invoke 'prepbuildsummary' function on any exit
# We use two traps to identify the signals, EXIT and INT. EXIT will invoke 'prepbuildoutput' function on any exit
# status >= 0. The script fail status is determined by the above pkgstatus or any premature compile failure.
# The 'interrruptsummary' function is invoked when the user sends CTRL-C aka SIGINT. The SIGINT trap does not work
# for auto builds, it has been added in the section build file too.
trap "prepbuildsummary" EXIT
trap "interruptsummary" INT
trap "prepbuildoutput" EXIT
trap "interruptoutput" INT
build